import { Controller, Get, Inject } from '@midwayjs/core';
import { AdminService } from '../service/user/admin.service';
import { ExamineeService } from '../service/user/examinee.service';

@Controller('/')
export class HomeController {
  @Inject()
  adminService: AdminService;

  @Inject()
  examineeService: ExamineeService;

  @Get('/')
  async home(): Promise<string> {
    return 'Hello Midwayjs!';
  }
  @Get('/init/admin')
  async initAdmin() {
    await this.adminService.initSuper();
    return 'ok';
  }

  @Get('/init/examinee')
  async initExaminee() {
    await this.examineeService.initUser();
    return 'ok';
  }
}
