import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
@modelOptions({
  schemaOptions: { collection: 'examinee' },
})
export class Examinee extends BaseModel {
  @prop({ required: true, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: object;
  @prop({ required: false, index: false, zh: '姓名' })
  name: string;
  @prop({ required: false, index: false, zh: '准考证号' })
  exam_num: string;
  @prop({ required: false, index: false, zh: '考点编号' })
  testsite_num: string;
  @prop({ required: false, index: false, zh: '性别' })
  gender: string;
  @prop({ required: false, index: false, zh: '联系电话' })
  phone: string;
  @prop({ required: false, index: false, zh: '考试日期' })
  exam_date: string;
  @prop({ required: false, index: false, zh: '考试时间' })
  exam_time: string;
  @prop({ required: false, index: false, zh: '考试地址' })
  exam_addr: string;
  @prop({ required: false, index: false, zh: '座位号' })
  seat_num: string;
  @prop({ required: false, index: false, zh: '考试等级' })
  exam_grade: string;
  @prop({ required: false, index: false, zh: '考试类型' })
  exam_type: string;
  @prop({ required: false, index: false, zh: '缴费状况' })
  is_money: string;
  @prop({ required: false, index: false, zh: '状态' })
  status: string;
}
