import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Examinee } from '../../entity/user/examinee.entity';
type modelType = ReturnModelType<typeof Examinee>;
@Provide()
export class ExamineeService extends BaseService<modelType> {
  @InjectEntityModel(Examinee)
  model: modelType;

  async initUser() {
    const data = {
      account: 'user',
      password: '1qaz2wsx',
      name: this.randomStr(),
      exam_num: this.randomStr(12),
      testsite_num: this.randomStr(8),
      gender: '男',
      phone: this.randomStr(13),
      exam_date: '2025-05-10',
      exam_time: '10:00',
      exam_addr: this.randomStr(),
      seat_num: 1,
      exam_grade: 1,
      exam_type: this.randomStr(),
      is_money: '已缴费',
      status: '0',
    };
    const res = await this.model.create(data);
    return res;
  }

  randomStr(len = 6) {
    return Math.random().toString(36).slice(-len);
  }
}
